#include "mbed.h"

//Include aes library
????

// Sensors drivers present in the BSP library
#include "stm32l475e_iot01_tsensor.h"

// Maximum number of element the application buffer can contain
#define MAXIMUM_BUFFER_SIZE 16

// Create a DigitalOutput object to toggle an LED whenever data is received.
static DigitalOut led(LED1);

// Create a BufferedSerial object with a default baud rate.
static BufferedSerial serial_port(USBTX, USBRX);

int main(void) {
	
	// Initialize temperature sensor
    BSP_TSENSOR_Init();


    // Set desired properties (9600-8-N-1).
    serial_port.set_baud(9600);
    serial_port.set_format(
    /* bits */ 8,
    /* parity */ BufferedSerial::None,
    /* stop bit */ 1);

	// Application buffer to receive the data
	uint8_t buf[MAXIMUM_BUFFER_SIZE] = {0};
	uint8_t trigger[MAXIMUM_BUFFER_SIZE] = {0};
	  
	uint8_t key[] = {0x5c, 0x7e, 0x15, 0x16, 0x28, 0xae, 0xd2, 0xa6, 0xab, 0xf7, 0x15, 0x88, 0x09, 0xcf, 0x4f, 0x3c};
					 
	//uint8_t plaintext[] = {0x6b, 0xc1, 0xbe, 0xe2, 0x2e, 0x40, 0x9f, 0x96, 0xe9, 0x3d, 0x7e, 0x11, 0x73, 0x93, 0x17, 0x2a};			   
	//uint8_t ciphertext[16];
	
	float sensor_value = 0;

	while (1) {
		
		// Get temperature value
		sensor_value = BSP_TSENSOR_ReadTemp();

		uint8_t tmpInt1 = sensor_value;

		float tmpFrac = sensor_value - tmpInt1;

		uint8_t tmpInt2 = trunc(tmpFrac * 100);

		buf[0] = tmpInt1;
		buf[1] = tmpInt2;

		if (uint32_t num = serial_port.read(trigger, sizeof(trigger))) {

			// Toggle the LED.
		    led = !led;

		    // Encrypt the plaintext using AES128
		    AES_ECB_encrypt(????, key, ????, ????);

		   // Echo the input back to the terminal.
		   //serial_port.write(data, sizeof(data));
		   serial_port.write(buf, sizeof(buf));
		}
  }
}